/***************************************************************************
 *   Copyright (C) 2009 by Stephen Allewell                                *
 *   stephen@mirramar.fsnet.co.uk                                          *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 ***************************************************************************/

#ifndef PREVIEWICONVIEW_H
#define PREVIEWICONVIEW_H

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <qwidget.h>
#include <qstring.h>
#include <kiconview.h>

class LibraryPattern;

class PreviewIconViewItem : public KIconViewItem
{
public:
    PreviewIconViewItem(QIconView *parent, LibraryPattern *pattern);

    void setLibraryPattern(LibraryPattern *libraryPattern);
    LibraryPattern *libraryPattern();
    bool acceptDrop(const QMimeSource *mimeSource);

protected:
    void dropped(QDropEvent *event, const QValueList<QIconDragItem> &list);

private:
    LibraryPattern *m_libraryPattern;
};

class PreviewIconView : public KIconView
{
public:
    PreviewIconView(QWidget *parent, QString name);

    void setScaleSize(int scaleSize);

protected:
    virtual QDragObject *dragObject();

private:
    int m_scaleSize;
};

#endif
